proc Nv_SeqDisplay { nm} {
    global Nv_Nresidues Seq SGL Nv_SeqDisp CSI Nv_Priv
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    toplevel $nm
    wm minsize $nm 1 1
    
    set Nv_SeqDisp(displayAtoms) "HA HB HN CA CB C N"
    #    set Nv_SeqDisp(csiAtoms) "HA HB HN CA CB C N"
    set Nv_SeqDisp(csiAtoms) "HA HN CA CB C N"
    set Nv_SeqDisp(csiDispMode) threshold
    set Nv_SeqDisp(csiDispType) CSI
    set Nv_SeqDisp(maxCSI) 1.0
    set Nv_SeqDisp(nfields) 50
    foreach atom $Nv_SeqDisp(displayAtoms) {
        set Nv_SeqDisp(displayAtom,$atom) 0
        set Nv_SeqDisp(csiAtom,$atom) 0
        set Nv_SeqDisp(csiAtom_old,$atom) 0
        set Nv_SeqDisp(csiCalcAtom,$atom) 0
    }
    
    set Nv_SeqDisp(fontSize) 10
    set Nv_SeqDisp(annoTypes) Cartoon
    set Nv_SeqDisp(anno,Cartoon) 0
    set Nv_SeqDisp(noes) "hnhn"
    set Nv_SeqDisp(noes,hnhn) 0
    set Nv_SeqDisp(displayAtom,HN) 1
    set Nv_SeqDisp(csiCalcAtom,CA) 0
    set Nv_SeqDisp(erase) 0
    set Nv_SeqDisp(ascii) 0
    
    set CSI(deuterated) 0
    set CSI(assignflag) 0
    set CSI(trosy) 0
    set CSI(ph) ""
    set CSI(temp) ""
    set CSI(assignfactor) ""
    set CSI(assign) ""
    
    
    set fr $nm.cntrlBar
    frame $fr
    pack $fr -side top -fill x
    
    button $fr.close -text Close -command "wm withdraw $nm"
    pack $fr.close -side left
    
    button $fr.options -text Options -command "NvSeqOptions $nm"
    pack $fr.options -side left
    
    button $fr.plot -text Plot -command "NvSeqPlot"
    pack $fr.plot -side left
    
    
    button $fr.colAss -text ColorAssigned -command "NvSeqColorAssign $nm"
    pack $fr.colAss -side left
    
    #    button $fr.calCSI -text CalcCSI -command "NvSeqCalCSI $nm;CSISec $nm;NvSeqMkCanvas"
    button $fr.calCSI -text CalcCSI -command "NvSeqOptionsCSI $nm"
    pack $fr.calCSI -side left

    button $fr.add -text Add -command "NvEditSeq"
    pack $fr.add -side left
    
    label $fr.sheetLabel -width 12 -text CurrentRes:
    label $fr.sheetStatus -width 4 -relief sunken -textvariable Nv_SeqDisp(CurrentRes)
    pack $fr.sheetLabel $fr.sheetStatus -side left
    
    set fr $nm.assignBar
    frame $fr
    pack $fr -side top -fill x
    
    label $fr.assignLabel -width 10 -text Assigned:
    label $fr.assignStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Assigned)
    pack $fr.assignLabel $fr.assignStatus -side left
    
    label $fr.sheetLabel -width 10 -text Sheet:
    label $fr.sheetStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Sheet)
    pack $fr.sheetLabel $fr.sheetStatus -side left
    
    label $fr.helixLabel -width 10 -text Helix:
    label $fr.helixStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Helix)
    pack $fr.helixLabel $fr.helixStatus -side left
    
    label $fr.colorcodelabel -text "CSI color coding:"
    pack $fr.colorcodelabel  -side top
    
    set fr $nm.statusBar
    frame $fr
    pack $fr -side top -fill x
    
    foreach item "Fragment Element Cluster" {
        set litem [string tolower $item]
        label $fr.${litem}Label -width 10  -text $item
        label $fr.${litem}Status -width 12 -relief sunken -textvariable Nv_SeqDisp($item)
        pack $fr.${litem}Label $fr.${litem}Status -side left
    }
    
    label $fr.colorcodelabel1 -width 13 -bg red -fg white -text "Positive (+1)."
    pack $fr.colorcodelabel1  -side left
    
    label $fr.colorcodelabel2 -width 9 -bg grey -fg black -text "Zero (0)."
    pack $fr.colorcodelabel2  -side left
    
    label $fr.colorcodelabel3 -width 13 -bg blue -fg white -text "Negative (-1)."
    pack $fr.colorcodelabel3  -side left
    
    
    frame $nm.fr1 -border 5 -relief raised -bg white
    pack $nm.fr1 -side top -fill both  -expand y
    set Nv_SeqDisp(canvas) $nm.fr1.canvas
    wm deiconify $nm
    raise $nm
    if {$Nv_Priv(javaMode)} {
        set molName [mol molname]
        mol select atoms ${molName}:*.CA
        foreach atom [mol listatoms] {
            set rname [nv_atom elem rname $atom]
            set j [nv_atom elem seq $atom]
            foreach atom $Nv_SeqDisp(csiAtoms) {
                set Seq($j,CSIdelta,$atom) 0.0
            }
        }
    } else {
        foreach residue [nv_list seq] {
            set j [lindex $residue 4]
            foreach atom $Nv_SeqDisp(csiAtoms) {
                set Seq($j,CSIdelta,$atom) 0.0
            }
        }
    }
    
    NvSeqMkCanvas
}

proc NvSeqDumpResAssign {nm i iRes} {
    global Seq Nv_Priv Nv_SeqDisp
    set varnm [NvVarnm $Nv_Priv(assignPanel)]
    global $varnm
    upvar #0 $varnm panvar
    
    if {$Seq($i) && [info exists Seq($i,Frag)] } {
        set Nv_SeqDisp(Fragment) $Seq($i,Frag)
        set Nv_SeqDisp(Element) $Seq($i,FragElem)
        set Nv_SeqDisp(Cluster) $Seq($i,clst)
	set Nv_SeqDisp(Cluster1) [lindex $Nv_SeqDisp(Cluster) 0]
	set Nv_SeqDisp(Cluster2) [lindex $Nv_SeqDisp(Cluster) 1]       
    } else {
        set Nv_SeqDisp(Fragment) ""
        set Nv_SeqDisp(Element) ""
        set Nv_SeqDisp(Cluster) ""
        set Nv_SeqDisp(Cluster1) ""
	set Nv_SeqDisp(Cluster2) ""
    }
    set panvar(curres2) $i
    set panvar(curres) $iRes
    NvUpdateAssignPan $Nv_Priv(assignPanel) set 0
}

proc NvEditSeq {} {
    global Nv_SeqDisp

    destroy .seqEdit
    toplevel .seqEdit

    set fr .seqEdit
    frame $fr.res
    frame  $fr.clust
    frame $fr.buttons
    pack $fr.res $fr.clust $fr.buttons -side top

    label $fr.res.label -text "Residue Number:"
    entry $fr.res.entry -textvariable Nv_SeqDisp(CurrentRes)
    pack $fr.res.label $fr.res.entry -side left

    label $fr.clust.iLab -text "Cluster i:"
    entry $fr.clust.ientry -textvariable Nv_SeqDisp(Cluster1) -width 6
    label $fr.clust.iplusLab -text "Cluster i+1:"
    entry $fr.clust.iplusEntry -textvariable Nv_SeqDisp(Cluster2) -width 6
    pack $fr.clust.iLab $fr.clust.ientry $fr.clust.iplusLab $fr.clust.iplusEntry -side left

    button $fr.buttons.save -text "Set this Residue" -command "NvSaveUpdate $Nv_SeqDisp(CurrentRes)"
    pack $fr.buttons.save -side left
}

proc NvSaveUpdate {i} {
    global Nv_SeqDisp Seq Fragment Clust ClusterData
    set Seq($i,clst) ""
    if {$Seq($i) == 0} {
    	set Seq($i) 1
   	set Seq($i,Frag) $Fragment(nFrag)
	incr Fragment(nFrag) 1
    	set Seq($i,FragElem) 0
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster1)
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster2)
	
    } else {
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster1)
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster2)
    }

    GetClustInfo $Nv_SeqDisp(Cluster1)
    set Nppm $Clust($Nv_SeqDisp(Cluster1),N)
    set HNppm $Clust($Nv_SeqDisp(Cluster1),HN)
    set CAppm $ClusterData($Nv_SeqDisp(Cluster1),CAi)
    set CBppm $ClusterData($Nv_SeqDisp(Cluster1),CBi)
    nv_atom elem ppm [nv_atom num $i.N] $Nppm
    nv_atom elem ppm [nv_atom num $i.HN] $HNppm
    nv_atom elem ppm [nv_atom num $i.CA] $CAppm
    nv_atom elem ppm [nv_atom num $i.CB] $CBppm

}
